/*----------------------*/
/* ApColorCube.java     */
/*----------------------*/
import java.applet.Applet;
import java.awt.*;                          //BorderLayout,GraphicsConfiguration,event
import javax.media.j3d.*;                   //Java3d
import com.sun.j3d.utils.applet.MainFrame;  //MainFrame
import com.sun.j3d.utils.universe.*;        //SimpleUniverse
import com.sun.j3d.utils.geometry.*;        //Primitive
import javax.vecmath.*;                     //Point3f,Color3f

public class ApColorCube extends Applet{

    private SimpleUniverse simpleU;
    private BoundingSphere bounds = new BoundingSphere(new Point3d(), 10.0);

    public void init(){

        //Avbg̒Canvas3Dǉ
        setLayout(new BorderLayout());
        Canvas3D canvas = new Canvas3D(SimpleUniverse.getPreferredConfiguration());
        add(canvas, BorderLayout.CENTER);

        //V[Ot̐
        simpleU = new SimpleUniverse(canvas);
        simpleU.getViewingPlatform().setNominalViewingTransform();

        //V[Ot̍쐬
        simpleU.addBranchGraph(createSceneGraph());
    }

    private BranchGroup createSceneGraph(){

        BranchGroup branchG0 = new BranchGroup();

        //wiF̐ݒiݒ肪ꍇ͍j
        Background background = new Background(new Color3f(1.0f, 1.0f, 1.0f));
        background.setApplicationBounds(bounds);
        branchG0.addChild(background);

        branchG0.addChild(createDirectionalLight());     //Cgǉ

        Transform3D rotationX = new Transform3D();
        Transform3D rotationY = new Transform3D();
        rotationX.rotX(Math.PI/6);                      //30x]
        rotationY.rotY(-Math.PI/9);                     //20x]
        rotationX.mul(rotationY);                       //
        TransformGroup transG0 = new TransformGroup(rotationX);
        branchG0.addChild(transG0);

        createAxis(transG0);                           //W̍쐬

        //_ɕ̂쐬
        ColorCube colorCube = new ColorCube(0.5);
        transG0.addChild(colorCube);

        branchG0.compile();

        return branchG0;
    }

    //₷悤ɍW
    private void createAxis(TransformGroup tg){

        Point3f[] vertex = new Point3f[6];
        vertex[0] = new Point3f(-1.0f, 0.0f, 0.0f);
        vertex[1] = new Point3f( 1.0f, 0.0f, 0.0f);
        vertex[2] = new Point3f( 0.0f,-1.0f, 0.0f);
        vertex[3] = new Point3f( 0.0f, 1.0f, 0.0f);
        vertex[4] = new Point3f( 0.0f, 0.0f,-1.0f);
        vertex[5] = new Point3f( 0.0f, 0.0f, 1.0f);

        Appearance ap = new Appearance();
        ColoringAttributes ca = new ColoringAttributes();
        ca.setColor(new Color3f(0.0f, 0.0f, 0.0f));
        ap.setColoringAttributes(ca);

        //2g̓_Ȃ
        LineArray LineA = new LineArray(vertex.length,
            GeometryArray.COORDINATES);
        LineA.setCoordinates(0, vertex);
        Shape3D line3D = new Shape3D(LineA, ap);
        tg.addChild(line3D);

        //W\ʒu
        Vector3f[] vector = new Vector3f[3];
        vector[0] = new Vector3f(  0.8f, 0.0f, 0.0f);
        vector[1] = new Vector3f( 0.05f, 0.8f, 0.0f);
        vector[2] = new Vector3f(-0.05f, 0.0f, 0.8f);

        String[] axis = {"x","y","z"};
        Transform3D trans = new Transform3D();
        for(int i=0;i<3;i++){
            trans.setTranslation(vector[i]);
            TransformGroup transG = new TransformGroup(trans);
            Text2D text2d = new Text2D(axis[i],                         //쐬
                                        new Color3f(0.0f, 0.0f, 0.0f),  //tHgF
                                        "Serif", 30, Font.BOLD);        //tHg
            transG.addChild(text2d);
            tg.addChild(transG);
        }
    }

    //s쐬
    private Light createDirectionalLight(){

        DirectionalLight lightD = new DirectionalLight();   //ftHg̕s
        lightD.setInfluencingBounds(bounds);                //e͈

        return lightD;
    }

    public void destroy(){

        simpleU.cleanup();
    }

    public static void main(String[] args){    //Application

        MainFrame frame = new MainFrame(new ApColorCube(), 256, 256);
    }
}

