/*--------------*/
/* Ex41.java    */
/*--------------*/
import java.applet.Applet;
import java.awt.*;                          //BorderLayout,GraphicsConfiguration,event
import javax.media.j3d.*;                   //Java3d
import com.sun.j3d.utils.applet.MainFrame;  //MainFrame
import com.sun.j3d.utils.universe.*;        //SimpleUniverse
import com.sun.j3d.utils.geometry.*;        //Primitive
import javax.vecmath.*;                     //Point3f,Color3f

public class Ex41 extends Applet{

    private SimpleUniverse simpleU;
    private BoundingSphere bounds = new BoundingSphere(new Point3d(), 10.0);

    public void init(){

        //Avbg̒Canvas3Dǉ
        setLayout(new BorderLayout());
        Canvas3D canvas = new Canvas3D(SimpleUniverse.getPreferredConfiguration());
        add(canvas, BorderLayout.CENTER);

        //V[Ot̐
        simpleU = new SimpleUniverse(canvas);
        simpleU.getViewingPlatform().setNominalViewingTransform();

        //V[Ot̍쐬
        simpleU.addBranchGraph(createSceneGraph());
    }

    private BranchGroup createSceneGraph(){

        //Transform3DIuWFNg
        Transform3D trans = new Transform3D();    //sړp
        Transform3D rot  = new Transform3D();     //]p

        BranchGroup branchG0 = new BranchGroup();

        //wiF̐ݒiݒ肪ꍇ͍j
        Background background = new Background(new Color3f(0.3f, 0.3f, 0.3f));
        background.setApplicationBounds(bounds);
        branchG0.addChild(background);

        //[v()]Appearance1쐬
        Appearance ap1 = new Appearance();
        ColoringAttributes ca1 = new ColoringAttributes();
        ca1.setColor(new Color3f( 0.5f, 0.9f, 0.5f));
        ap1.setColoringAttributes(ca1);
        //[v()]Appearance2쐬
        Appearance ap2 = new Appearance();
        ColoringAttributes ca2 = new ColoringAttributes();
        ca2.setColor(new Color3f( 0.7f, 1.0f, 0.7f));
        ap2.setColoringAttributes(ca2);
        //[]Appearance3쐬
        Appearance ap3 = new Appearance();
        ColoringAttributes ca3 = new ColoringAttributes();
        ca3.setColor(new Color3f( 1.0f, 1.0f, 0.4f));
        ap3.setColoringAttributes(ca3);
        //add ===============================================
        //[j]Appearance쐬
        Appearance ap = new Appearance();
        ColoringAttributes ca = new ColoringAttributes();
        ca.setColor(new Color3f( 0.0f, 0.0f, 0.0f));
        ap.setColoringAttributes(ca);
        //add ===============================================

        //transG0Fȉ̊􉽕ϊ̎܂Ƃ߃m[h
        TransformGroup transG0 = new TransformGroup();
        branchG0.addChild(transG0);

        //[v]쐬
        rot.rotX(Math.PI/2);                 //90x]
        TransformGroup transG1 = new TransformGroup(rot);
        transG0.addChild(transG1);
        Cylinder cylinder1 = new Cylinder(0.60f, 0.30f, ap1);
        Cylinder cylinder2 = new Cylinder(0.42f, 0.31f, ap2);
        transG1.addChild(cylinder1);
        transG1.addChild(cylinder2);

        //[]쐬
        trans.setTranslation(new Vector3f(0.0f, -0.65f, 0.0f));
        TransformGroup transG2 = new TransformGroup(trans);
        transG0.addChild(transG2);
        Box box1 = new Box(0.5f, 0.1f, 0.3f, ap3);
        transG2.addChild(box1);

        //add ===============================================
        //jEZjpm[h
        trans.setTranslation(new Vector3f(0.0f, 0.0f, 0.2f)); //vՕ\ʂɈړ
        TransformGroup transG3 = new TransformGroup(trans);
        transG0.addChild(transG3);
        //j쐬
        Point3f[] points1 = new Point3f[4];
        points1[0] = new Point3f( 0.01f,  0.00f, 0.0f);
        points1[1] = new Point3f( 0.01f,  0.40f, 0.0f);
        points1[2] = new Point3f(-0.01f,  0.40f, 0.0f);
        points1[3] = new Point3f(-0.01f,  0.00f, 0.0f);
        QuadArray quadA1
            = new QuadArray(points1.length, GeometryArray.COORDINATES);
        quadA1.setCoordinates(0, points1);
        Shape3D shape1 = new Shape3D(quadA1, ap);
        transG3.addChild(shape1);
        //Zjpm[h
        trans.rotZ(-Math.PI/2);
        TransformGroup transG4 = new TransformGroup(trans);
        transG3.addChild(transG4);
        //Zj쐬
        Point3f[] points2 = new Point3f[4];
        points2[0] = new Point3f( 0.02f,  0.00f, 0.0f);
        points2[1] = new Point3f( 0.02f,  0.30f, 0.0f);
        points2[2] = new Point3f(-0.02f,  0.30f, 0.0f);
        points2[3] = new Point3f(-0.02f,  0.00f, 0.0f);
        QuadArray quadA2
            = new QuadArray(points2.length, GeometryArray.COORDINATES);
        quadA2.setCoordinates(0, points2);
        Shape3D shape2 = new Shape3D(quadA2, ap);
        transG4.addChild(shape2);
        //add ===============================================

        branchG0.compile();

        return branchG0;
    }

    public void destroy(){

        simpleU.cleanup();
    }

    public static void main(String[] args){    //Application

        MainFrame frame = new MainFrame(new Ex41(), 512, 512);
    }
}

