/*------------*/
/* Ex62.java  */
/*------------*/
import java.applet.Applet;
import java.awt.*;                          //BorderLayout,GraphicsConfiguration,event
import javax.media.j3d.*;                   //Java3d
import com.sun.j3d.utils.applet.MainFrame;  //MainFrame
import com.sun.j3d.utils.universe.*;        //SimpleUniverse
import com.sun.j3d.utils.geometry.*;        //Primitive
import javax.vecmath.*;                     //Point3f,Color3f

public class Ex62 extends Applet{

    private SimpleUniverse simpleU;
    private BoundingSphere bounds = new BoundingSphere(new Point3d(), 10.0);

    public void init(){

        //Avbg̒Canvas3Dǉ
        setLayout(new BorderLayout());
        Canvas3D canvas = new Canvas3D(SimpleUniverse.getPreferredConfiguration());
        add(canvas, BorderLayout.CENTER);

        //V[Ot̐
        simpleU = new SimpleUniverse(canvas);
        simpleU.getViewingPlatform().setNominalViewingTransform();

        //V[Ot̍쐬
        simpleU.addBranchGraph(createSceneGraph());
    }

    private BranchGroup createSceneGraph(){

        Transform3D trans = new Transform3D();

        BranchGroup branchG0 = new BranchGroup();

        //wiF̐ݒiݒ肪ꍇ͍j
        Background background = new Background(new Color3f(0.3f, 0.3f, 0.3f));
        background.setApplicationBounds(bounds);
        branchG0.addChild(background);

        //Interpolatorp̃m[h
        TransformGroup transG0 = new TransformGroup();
        branchG0.addChild(transG0);

        //ǉ
        branchG0.addChild(createDirectionalLight());        //s
        transG0.addChild(createPointLight());               //_

        //Appearance쐬
        Appearance ap = new Appearance();
        Material ma = new Material();
        ap.setMaterial(ma);
        //Appearance[]쐬
        Appearance ap2 = new Appearance();
        Material ma2 = new Material();
        ma2.setDiffuseColor(new Color3f(0.0f, 0.0f, 0.0f));
        ma2.setEmissiveColor(new Color3f(1.0f, 0.0f, 0.0f));
        ap2.setMaterial(ma2);

        //_ɋ쐬
        Sphere sphere = new Sphere(0.5f, Primitive.GENERATE_NORMALS, 80, ap);
        branchG0.addChild(sphere);
        //̂쐬
        trans.setTranslation(new Vector3f(-0.8f, 0.0f, 0.0f));
        TransformGroup transG1 = new TransformGroup(trans);
        transG0.addChild(transG1);
        Box box = new Box(0.01f, 0.01f, 0.01f, ap2);
        transG1.addChild(box);

        //]̃Aj[Vݒ
        transG0.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        Transform3D rotAxis = new Transform3D();
        Alpha rotationAlpha = new Alpha(-1, 4000);          //14s,JԂ
        RotationInterpolator rotator =                      //Y܂̉]
            new RotationInterpolator(rotationAlpha, transG0, rotAxis,
                         0.0f, (float)Math.PI*2.0f);        //Jnʒu,Iʒu
        rotator.setSchedulingBounds(bounds);
        transG0.addChild(rotator);

        branchG0.compile();

        return branchG0;
    }

    //s쐬
    private Light createDirectionalLight(){

        DirectionalLight lightD = new DirectionalLight(
                        true,                               //CgON/OFF
                        new Color3f(1.0f, 1.0f, 0.0f),      //̐F
                        new Vector3f(-1.0f, -1.0f, -1.0f)   //̂
        );
        lightD.setInfluencingBounds(bounds);                //e͈

        return lightD;
    }

    //_쐬
    private Light createPointLight(){

        PointLight lightP = new PointLight(
                  true,                           //CgON/OFF
                  new Color3f(1.0f, 0.0f, 0.0f),  //Ԃ̌
                  new Point3f(-0.7f, 0.0f, 0.0f), //̈ʒu
                  new Point3f(1.0f, 0.0f, 0.0f)   //̌iconstant,linear,quadraticj
        );
        lightP.setInfluencingBounds(bounds);      //e͈

        return lightP;
    }

    public void destroy(){

        simpleU.cleanup();
    }

    public static void main(String[] args){    //Application

        MainFrame frame = new MainFrame(new Ex62(), 512, 512);
    }
}

