/*--------------*/
/* Ex71.java    */
/*--------------*/
import java.applet.Applet;
import java.awt.*;                            //BorderLayout,GraphicsConfiguration,event
import javax.media.j3d.*;                     //Java3d
import com.sun.j3d.utils.applet.MainFrame;    //MainFrame
import com.sun.j3d.utils.universe.*;          //SimpleUniverse
import com.sun.j3d.utils.geometry.*;          //Primitive
import com.sun.j3d.utils.behaviors.mouse.*;   //Mouse
import com.sun.j3d.utils.image.TextureLoader; //TextureLoader
import javax.vecmath.*;                       //Point3f,Color3f

public class Ex71 extends Applet{

    private SimpleUniverse simpleU;
    private BoundingSphere bounds = new BoundingSphere(new Point3d(), 10.0);

    public void init() {

        //Avbg̒Canvas3Dǉ
        setLayout(new BorderLayout());
        Canvas3D canvas = new Canvas3D(SimpleUniverse.getPreferredConfiguration());
        add(canvas, BorderLayout.CENTER);

        //V[Ot̐
        simpleU = new SimpleUniverse(canvas);
        simpleU.getViewingPlatform().setNominalViewingTransform();

        //V[Ot̍쐬
        simpleU.addBranchGraph(createSceneGraph());
    }

    public BranchGroup createSceneGraph(){

        Transform3D rotx = new Transform3D();
        Transform3D roty = new Transform3D();

        BranchGroup branchG0 = new BranchGroup();

        //wiF̐ݒiݒ肪ꍇ͍j
        Background background = new Background(new Color3f(0.3f, 0.3f, 0.3f));
        background.setApplicationBounds(bounds);
        branchG0.addChild(background);

        //}EXp̃m[h
        TransformGroup transG0 = new TransformGroup();
        branchG0.addChild(transG0);

        //Appearance쐬
        Appearance ap = new Appearance();
        ColoringAttributes ca = new ColoringAttributes();
        ca.setColor(new Color3f( 0.0f, 0.0f, 1.0f));    //F
        ap.setColoringAttributes(ca);

        //eNX`
        TextureLoader loader = new TextureLoader("java3d.JPG", this);
        ap.setTexture(loader.getTexture());

        //WnX
        rotx.rotX(Math.PI/6.0);
        roty.rotY(-Math.PI/4.0);
        rotx.mul(roty);
        TransformGroup transG1 = new TransformGroup(rotx);
        transG0.addChild(transG1);
        Box primitive = new Box(0.5f, 0.5f, 0.5f, Box.GENERATE_TEXTURE_COORDS, ap);
//        Cylinder primitive = new Cylinder(0.5f, 1.0f, Cylinder.GENERATE_TEXTURE_COORDS, ap);
//        Sphere primitive = new Sphere(0.5f, Sphere.GENERATE_TEXTURE_COORDS, 50, ap);
        transG1.addChild(primitive);

        //}EXɂ镨̈ړ
        transG0.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        transG0.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        MouseRotate mouseRot = new MouseRotate(transG0);
        mouseRot.setSchedulingBounds(bounds);
        transG0.addChild(mouseRot);

        branchG0.compile();

        return branchG0;
    }

    public void destroy(){

        simpleU.cleanup();
    }

    public static void main(String[] args){    //Application

        MainFrame frame = new MainFrame(new Ex71(), 512, 512);
    }
}
