/*--------------*/
/* Ex82.java    */
/*--------------*/
import java.applet.Applet;
import java.awt.*;                              //BorderLayout,GraphicsConfiguration,event
import javax.media.j3d.*;                       //Java3d
import com.sun.j3d.utils.applet.MainFrame;      //MainFrame
import com.sun.j3d.utils.universe.*;            //SimpleUniverse
import com.sun.j3d.utils.geometry.*;            //Primitive
import com.sun.j3d.utils.behaviors.keyboard.*;  //Keyboard
import com.sun.j3d.utils.behaviors.mouse.*;     //Mouse      @add
import javax.vecmath.*;                         //Point3f,Color3f

public class Ex82 extends Applet{

    private SimpleUniverse simpleU;
    private TransformGroup vpTrans;
    private BoundingSphere bounds = new BoundingSphere(new Point3d(), 10.0);

    public void init(){

        //Avbg̒Canvas3Dǉ
        setLayout(new BorderLayout());
        Canvas3D canvas = new Canvas3D(SimpleUniverse.getPreferredConfiguration());
        add(canvas, BorderLayout.CENTER);

        //V[Ot̐
        simpleU = new SimpleUniverse(canvas);
        simpleU.getViewingPlatform().setNominalViewingTransform();

        //V[Ot̍쐬
        vpTrans = simpleU.getViewingPlatform().getViewPlatformTransform();
        simpleU.addBranchGraph(createSceneGraph());
    }

    private BranchGroup createSceneGraph(){

        BranchGroup branchG0 = new BranchGroup();

        //L[{[hɂ鎋_ύX
        KeyNavigatorBehavior keybehavior = new KeyNavigatorBehavior(vpTrans);
        keybehavior.setSchedulingBounds(bounds);
        branchG0.addChild(keybehavior);
        //}EXɂ鎋_ύX   @add
        MouseRotate mouseRot = new MouseRotate(vpTrans);
        MouseTranslate mouseTrans = new MouseTranslate(vpTrans);
        MouseZoom mouseZoom = new MouseZoom(vpTrans);
        mouseRot.setSchedulingBounds(bounds);
        mouseTrans.setSchedulingBounds(bounds);
        mouseZoom.setSchedulingBounds(bounds);
        branchG0.addChild(mouseRot);
        branchG0.addChild(mouseTrans);
        branchG0.addChild(mouseZoom);

        //wiF̐ݒiݒ肪ꍇ͍j
        Background background = new Background(new Color3f(0.3f, 0.3f, 0.3f));
        background.setApplicationBounds(bounds);
        branchG0.addChild(background);

        //ColorCube̐
        ColorCube colorCube = new ColorCube(0.2f);
        branchG0.addChild(colorCube);

        branchG0.compile();

        return branchG0;
    }

    public void destroy(){

        simpleU.cleanup();
    }

    public static void main(String[] args){    //Application

        MainFrame frame = new MainFrame(new Ex82(), 512, 512);
    }
}

