/*------------*/
/* Ja62.java  */
/*------------*/
import java.applet.Applet;
import java.awt.*;                          //BorderLayout,GraphicsConfiguration,event
import javax.media.j3d.*;                   //Java3d
import com.sun.j3d.utils.applet.MainFrame;  //MainFrame
import com.sun.j3d.utils.universe.*;        //SimpleUniverse
import com.sun.j3d.utils.behaviors.mouse.*; //Mouse
import javax.vecmath.*;                     //Point3f,Color3f

public class Ja62 extends Applet{

    private SimpleUniverse simpleU;
    private BoundingSphere bounds = new BoundingSphere(new Point3d(), 10.0);

    public void init(){

        //Avbg̒Canvas3Dǉ
        setLayout(new BorderLayout());
        Canvas3D canvas = new Canvas3D(SimpleUniverse.getPreferredConfiguration());
        add(canvas, BorderLayout.CENTER);

        //V[Ot̐
        simpleU = new SimpleUniverse(canvas);
        simpleU.getViewingPlatform().setNominalViewingTransform();

        //V[Ot̍쐬
        simpleU.addBranchGraph(createSceneGraph());
    }

    private BranchGroup createSceneGraph(){

        BranchGroup branchG0 = new BranchGroup();

        //wiF̐ݒiݒ肪ꍇ͍j
        Background background = new Background(new Color3f(0.3f, 0.3f, 0.3f));
        background.setApplicationBounds(bounds);
        branchG0.addChild(background);

        //ǉ
        branchG0.addChild(createDirectionalLight());

        //}EXp̃m[h
        TransformGroup transG0 = new TransformGroup();
        branchG0.addChild(transG0);

        //lp`|SAppearance쐬
        Appearance ap = new Appearance();
        PolygonAttributes pa = new PolygonAttributes();
        pa.setCullFace(PolygonAttributes.CULL_NONE);        //ʂ\
        pa.setBackFaceNormalFlip(true);                     //ʂɂ@ݒ
        ap.setPolygonAttributes(pa);
        ColoringAttributes ca = new ColoringAttributes();
        ca.setColor(new Color3f( 0.0f, 0.0f, 1.0f));        //F
        ap.setColoringAttributes(ca);
        Material ma = new Material();                       //Material쐬
        ap.setMaterial(ma);                                 //ftHgF
        //lp`|S̒_Wݒ
        Point3f[] vertex = new Point3f[4];
        vertex[0] = new Point3f( 0.5f,  0.5f, 0.0f);
        vertex[1] = new Point3f(-0.5f,  0.5f, 0.0f);
        vertex[2] = new Point3f(-0.5f, -0.5f, 0.0f);
        vertex[3] = new Point3f( 0.5f, -0.5f, 0.0f);
        QuadArray quadA
            = new QuadArray(vertex.length,
                GeometryArray.COORDINATES | GeometryArray.NORMALS);  //@ǉ
        quadA.setCoordinates(0, vertex);
        //_̖@ݒ肷
        Vector3f[] normal = new Vector3f[4];
        normal[0] = new Vector3f( 0.4f, 0.4f, 0.7f);
        normal[1] = new Vector3f(-0.4f, 0.4f, 0.7f);
        normal[2] = new Vector3f(-0.4f,-0.4f, 0.7f);
        normal[3] = new Vector3f( 0.4f,-0.4f, 0.7f);
        for(int i=0; i<4; i++){
            normal[i].normalize();                          //Ki
        }
        quadA.setNormals(0, normal);                        //e_ɖ@ݒ肷
        Shape3D quad3D = new Shape3D(quadA, ap);
        transG0.addChild(quad3D);

        //Qlׂ̈ɖ@
        for(int i=0; i<4; i++){
            transG0.addChild(drawNormal(vertex[i], normal[i]));
        }

        //}EXɂ镨̈ړ
        transG0.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        transG0.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        MouseRotate mouseRot = new MouseRotate(transG0);
        mouseRot.setSchedulingBounds(bounds);
        transG0.addChild(mouseRot);

        branchG0.compile();

        return branchG0;
    }

    //s쐬
    private Light createDirectionalLight(){

        DirectionalLight lightD = new DirectionalLight();   //ftHg̕s
        lightD.setInfluencingBounds(bounds);                //e͈

        return lightD;
    }

    //@쐬
    private Shape3D drawNormal(Point3f point1, Vector3f vec){

        Point3f point2 = new Point3f(point1);
        Point3f[] vertex = new Point3f[2];
        Color3f[] color = new Color3f[2];

        vec.scale(0.5f);
        point2.add(vec);

        vertex[0] = point1;
        vertex[1] = point2;
        color[0] = new Color3f( 1.0f, 1.0f, 0.0f);
        color[1] = new Color3f( 1.0f, 1.0f, 0.0f);

        LineArray lineA
            = new LineArray(vertex.length,
                GeometryArray.COORDINATES | GeometryArray.COLOR_3);
        lineA.setCoordinates(0, vertex);
        lineA.setColors(0, color);
        Shape3D line3D = new Shape3D(lineA);

        return line3D;
    }

    public void destroy(){

        simpleU.cleanup();
    }

    public static void main(String[] args){    //Application

        MainFrame frame = new MainFrame(new Ja62(), 512, 512);
    }
}

